SFML - Simple and Fast Multimedia Library

SFML 2.5.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | List of all members
sf::Music Class Reference
Audio module

Streamed music played from an audio file. More...

`#include <Music.hpp>`

Inheritance diagram for sf::Music:

## Classes
struct | Span
| Structure defining a time range using the template type. More...

## Public Types
typedef Span< Time > | TimeSpan
enum | Status { Stopped , Paused , Playing }
| Enumeration of the sound source states. More...

## Public Member Functions
| Music ()
| Default constructor. More...
| ~Music ()
| Destructor. More...
bool | openFromFile (const std::string &filename)
| Open a music from an audio file. More...
bool | openFromMemory (const void *data, std::size_t sizeInBytes)
| Open a music from an audio file in memory. More...
bool | openFromStream (InputStream &stream)
| Open a music from an audio file in a custom stream. More...
Time | getDuration () const
| Get the total duration of the music. More...
TimeSpan | getLoopPoints () const
| Get the positions of the of the sound's looping sequence. More...
void | setLoopPoints (TimeSpan timePoints)
| Sets the beginning and end of the sound's looping sequence using sf::Time. More...
void | play ()
| Start or resume playing the audio stream. More...
void | pause ()
| Pause the audio stream. More...
void | stop ()
| Stop playing the audio stream. More...
unsigned int | getChannelCount () const
| Return the number of channels of the stream. More...
unsigned int | getSampleRate () const
| Get the stream sample rate of the stream. More...
Status | getStatus () const
| Get the current status of the stream (stopped, paused, playing) More...
void | setPlayingOffset (Time timeOffset)
| Change the current playing position of the stream. More...
Time | getPlayingOffset () const
| Get the current playing position of the stream. More...
void | setLoop (bool loop)
| Set whether or not the stream should loop after reaching the end. More...
bool | getLoop () const
| Tell whether or not the stream is in loop mode. More...
void | setPitch (float pitch)
| Set the pitch of the sound. More...
void | setVolume (float volume)
| Set the volume of the sound. More...
void | setPosition (float x, float y, float z)
| Set the 3D position of the sound in the audio scene. More...
void | setPosition (const Vector3f &position)
| Set the 3D position of the sound in the audio scene. More...
void | setRelativeToListener (bool relative)
| Make the sound's position relative to the listener or absolute. More...
void | setMinDistance (float distance)
| Set the minimum distance of the sound. More...
void | setAttenuation (float attenuation)
| Set the attenuation factor of the sound. More...
float | getPitch () const
| Get the pitch of the sound. More...
float | getVolume () const
| Get the volume of the sound. More...
Vector3f | getPosition () const
| Get the 3D position of the sound in the audio scene. More...
bool | isRelativeToListener () const
| Tell whether the sound's position is relative to the listener or is absolute. More...
float | getMinDistance () const
| Get the minimum distance of the sound. More...
float | getAttenuation () const
| Get the attenuation factor of the sound. More...

## Protected Types
enum | { NoLoop = -1 }

## Protected Member Functions
virtual bool | onGetData (Chunk &data)
| Request a new chunk of audio samples from the stream source. More...
virtual void | onSeek (Time timeOffset)
| Change the current playing position in the stream source. More...
virtual Int64 | onLoop ()
| Change the current playing position in the stream source to the loop offset. More...
void | initialize (unsigned int channelCount, unsigned int sampleRate)
| Define the audio stream parameters. More...

## Protected Attributes
unsigned int | m_source
| OpenAL source identifier. More...

## Detailed Description

Streamed music played from an audio file.

Musics are sounds that are streamed rather than completely loaded in memory.

This is especially useful for compressed musics that usually take hundreds of MB when they are uncompressed: by streaming it instead of loading it entirely, you avoid saturating the memory and have almost no loading delay. This implies that the underlying resource (file, stream or memory buffer) must remain valid for the lifetime of the sf::Music object.

Apart from that, a sf::Music has almost the same features as the sf::SoundBuffer / sf::Sound pair: you can play/pause/stop it, request its parameters (channels, sample rate), change the way it is played (pitch, volume, 3D position, ...), etc.

As a sound stream, a music is played in its own thread in order not to block the rest of the program. This means that you can leave the music alone after calling play(), it will manage itself very well.

Usage example:

// Declare a new music
sf::Music music;
// Open it from an audio file
if (!music.openFromFile("music.ogg"))
{
// error...
}
// Change some parameters
music.setPosition(0, 1, 10); // change its 3D position
music.setPitch(2); // increase the pitch
music.setVolume(50); // reduce the volume
music.setLoop(true); // make it loop
// Play it
music.play();
sf::Music
Streamed music played from an audio file.
Definition: Music.hpp:49
sf::Music::openFromFile
bool openFromFile(const std::string &filename)
Open a music from an audio file.
sf::SoundSource::setPosition
void setPosition(float x, float y, float z)
Set the 3D position of the sound in the audio scene.
sf::SoundSource::setVolume
void setVolume(float volume)
Set the volume of the sound.
sf::SoundSource::setPitch
void setPitch(float pitch)
Set the pitch of the sound.
sf::SoundStream::setLoop
void setLoop(bool loop)
Set whether or not the stream should loop after reaching the end.
sf::SoundStream::play
void play()
Start or resume playing the audio stream.

See also
  sf::Sound, sf::SoundStream

Definition at line 48 of file Music.hpp.

## Member Typedef Documentation

## ◆ TimeSpan

typedef Span<Time> sf::Music::TimeSpan

Definition at line 87 of file Music.hpp.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| protectedinherited

Enumerator
NoLoop | "Invalid" endSeeks value, telling us to continue uninterrupted

Definition at line 183 of file SoundStream.hpp.

## ◆ Status

enum sf::SoundSource::Status
| inherited

Enumeration of the sound source states.

Enumerator
Stopped | Sound is not playing.
Paused | Sound is paused.
Playing | Sound is playing.

Definition at line 50 of file SoundSource.hpp.

## Constructor & Destructor Documentation

## ◆ Music()

sf::Music::Music | ( |  | ) |

Default constructor.

## ◆ ~Music()

sf::Music::~Music | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ getAttenuation()

float sf::SoundSource::getAttenuation | ( |  | ) | const
| inherited

Get the attenuation factor of the sound.

Returns
  Attenuation factor of the sound

See also
  setAttenuation, getMinDistance

## ◆ getChannelCount()

unsigned int sf::SoundStream::getChannelCount | ( |  | ) | const
| inherited

Return the number of channels of the stream.

1 channel means a mono sound, 2 means stereo, etc.

Returns
  Number of channels

## ◆ getDuration()

Time sf::Music::getDuration | ( |  | ) | const

Get the total duration of the music.

Returns
  Music duration

## ◆ getLoop()

bool sf::SoundStream::getLoop | ( |  | ) | const
| inherited

Tell whether or not the stream is in loop mode.

Returns
  True if the stream is looping, false otherwise

See also
  setLoop

## ◆ getLoopPoints()

TimeSpan sf::Music::getLoopPoints | ( |  | ) | const

Get the positions of the of the sound's looping sequence.

Returns
  Loop Time position class.

Warning
  Since setLoopPoints() performs some adjustments on the provided values and rounds them to internal samples, a call to getLoopPoints() is not guaranteed to return the same times passed into a previous call to setLoopPoints(). However, it is guaranteed to return times that will map to the valid internal samples of this Music if they are later passed to setLoopPoints().

See also
  setLoopPoints

## ◆ getMinDistance()

float sf::SoundSource::getMinDistance | ( |  | ) | const
| inherited

Get the minimum distance of the sound.

Returns
  Minimum distance of the sound

See also
  setMinDistance, getAttenuation

## ◆ getPitch()

float sf::SoundSource::getPitch | ( |  | ) | const
| inherited

Get the pitch of the sound.

Returns
  Pitch of the sound

See also
  setPitch

## ◆ getPlayingOffset()

Time sf::SoundStream::getPlayingOffset | ( |  | ) | const
| inherited

Get the current playing position of the stream.

Returns
  Current playing position, from the beginning of the stream

See also
  setPlayingOffset

## ◆ getPosition()

Vector3f sf::SoundSource::getPosition | ( |  | ) | const
| inherited

Get the 3D position of the sound in the audio scene.

Returns
  Position of the sound

See also
  setPosition

## ◆ getSampleRate()

unsigned int sf::SoundStream::getSampleRate | ( |  | ) | const
| inherited

Get the stream sample rate of the stream.

The sample rate is the number of audio samples played per second. The higher, the better the quality.

Returns
  Sample rate, in number of samples per second

## ◆ getStatus()

Status sf::SoundStream::getStatus | ( |  | ) | const
| virtualinherited

Get the current status of the stream (stopped, paused, playing)

Returns
  Current status

Reimplemented from sf::SoundSource.

## ◆ getVolume()

float sf::SoundSource::getVolume | ( |  | ) | const
| inherited

Get the volume of the sound.

Returns
  Volume of the sound, in the range [0, 100]

See also
  setVolume

## ◆ initialize()

void sf::SoundStream::initialize | ( | unsigned int | channelCount,
|  | unsigned int | sampleRate
| ) |  |
| protectedinherited

Define the audio stream parameters.

This function must be called by derived classes as soon as they know the audio settings of the stream to play. Any attempt to manipulate the stream (play(), ...) before calling this function will fail. It can be called multiple times if the settings of the audio stream change, but only when the stream is stopped.

Parameters

  channelCount | Number of channels of the stream
  sampleRate | Sample rate, in samples per second

## ◆ isRelativeToListener()

bool sf::SoundSource::isRelativeToListener | ( |  | ) | const
| inherited

Tell whether the sound's position is relative to the listener or is absolute.

Returns
  True if the position is relative, false if it's absolute

See also
  setRelativeToListener

## ◆ onGetData()

virtual bool sf::Music::onGetData | ( | Chunk & | data | ) |
| protectedvirtual

Request a new chunk of audio samples from the stream source.

This function fills the chunk from the next samples to read from the audio file.

Parameters

  data | Chunk of data to fill

Returns
  True to continue playback, false to stop

Implements sf::SoundStream.

## ◆ onLoop()

virtual Int64 sf::Music::onLoop | ( |  | ) |
| protectedvirtual

Change the current playing position in the stream source to the loop offset.

This is called by the underlying SoundStream whenever it needs us to reset the seek position for a loop. We then determine whether we are looping on a loop point or the end-of-file, perform the seek, and return the new position.

Returns
  The seek position after looping (or -1 if there's no loop)

Reimplemented from sf::SoundStream.

## ◆ onSeek()

virtual void sf::Music::onSeek | ( | Time | timeOffset | ) |
| protectedvirtual

Change the current playing position in the stream source.

Parameters

  timeOffset | New playing position, from the beginning of the music

Implements sf::SoundStream.

## ◆ openFromFile()

bool sf::Music::openFromFile | ( | const std::string & | filename | ) |

Open a music from an audio file.

This function doesn't start playing the music (call play() to do so). See the documentation of sf::InputSoundFile for the list of supported formats.

Warning
  Since the music is not loaded at once but rather streamed continuously, the file must remain accessible until the sf::Music object loads a new music or is destroyed.

Parameters

  filename | Path of the music file to open

Returns
  True if loading succeeded, false if it failed

See also
  openFromMemory, openFromStream

## ◆ openFromMemory()

bool sf::Music::openFromMemory | ( | const void * | data,
|  | std::size_t | sizeInBytes
| ) |  |

Open a music from an audio file in memory.

This function doesn't start playing the music (call play() to do so). See the documentation of sf::InputSoundFile for the list of supported formats.

Warning
  Since the music is not loaded at once but rather streamed continuously, the data buffer must remain accessible until the sf::Music object loads a new music or is destroyed. That is, you can't deallocate the buffer right after calling this function.

Parameters

  data | Pointer to the file data in memory
  sizeInBytes | Size of the data to load, in bytes

Returns
  True if loading succeeded, false if it failed

See also
  openFromFile, openFromStream

## ◆ openFromStream()

bool sf::Music::openFromStream | ( | InputStream & | stream | ) |

Open a music from an audio file in a custom stream.

This function doesn't start playing the music (call play() to do so). See the documentation of sf::InputSoundFile for the list of supported formats.

Warning
  Since the music is not loaded at once but rather streamed continuously, the stream must remain accessible until the sf::Music object loads a new music or is destroyed.

Parameters

  stream | Source stream to read from

Returns
  True if loading succeeded, false if it failed

See also
  openFromFile, openFromMemory

## ◆ pause()

void sf::SoundStream::pause | ( |  | ) |
| virtualinherited

Pause the audio stream.

This function pauses the stream if it was playing, otherwise (stream already paused or stopped) it has no effect.

See also
  play, stop

Implements sf::SoundSource.

## ◆ play()

void sf::SoundStream::play | ( |  | ) |
| virtualinherited

Start or resume playing the audio stream.

This function starts the stream if it was stopped, resumes it if it was paused, and restarts it from the beginning if it was already playing. This function uses its own thread so that it doesn't block the rest of the program while the stream is played.

See also
  pause, stop

Implements sf::SoundSource.

## ◆ setAttenuation()

void sf::SoundSource::setAttenuation | ( | float | attenuation | ) |
| inherited

Set the attenuation factor of the sound.

The attenuation is a multiplicative factor which makes the sound more or less loud according to its distance from the listener. An attenuation of 0 will produce a non-attenuated sound, i.e. its volume will always be the same whether it is heard from near or from far. On the other hand, an attenuation value such as 100 will make the sound fade out very quickly as it gets further from the listener. The default value of the attenuation is 1.

Parameters

  attenuation | New attenuation factor of the sound

See also
  getAttenuation, setMinDistance

## ◆ setLoop()

void sf::SoundStream::setLoop | ( | bool | loop | ) |
| inherited

Set whether or not the stream should loop after reaching the end.

If set, the stream will restart from beginning after reaching the end and so on, until it is stopped or setLoop(false) is called. The default looping state for streams is false.

Parameters

  loop | True to play in loop, false to play once

See also
  getLoop

## ◆ setLoopPoints()

void sf::Music::setLoopPoints | ( | TimeSpan | timePoints | ) |

Sets the beginning and end of the sound's looping sequence using sf::Time.

Loop points allow one to specify a pair of positions such that, when the music is enabled for looping, it will seamlessly seek to the beginning whenever it encounters the end. Valid ranges for timePoints.offset and timePoints.length are [0, Dur) and (0, Dur-offset] respectively, where Dur is the value returned by getDuration(). Note that the EOF "loop point" from the end to the beginning of the stream is still honored, in case the caller seeks to a point after the end of the loop range. This function can be safely called at any point after a stream is opened, and will be applied to a playing sound without affecting the current playing offset.

Warning
  Setting the loop points while the stream's status is Paused will set its status to Stopped. The playing offset will be unaffected.

Parameters

  timePoints | The definition of the loop. Can be any time points within the sound's length

See also
  getLoopPoints

## ◆ setMinDistance()

void sf::SoundSource::setMinDistance | ( | float | distance | ) |
| inherited

Set the minimum distance of the sound.

The "minimum distance" of a sound is the maximum distance at which it is heard at its maximum volume. Further than the minimum distance, it will start to fade out according to its attenuation factor. A value of 0 ("inside the head of the listener") is an invalid value and is forbidden. The default value of the minimum distance is 1.

Parameters

  distance | New minimum distance of the sound

See also
  getMinDistance, setAttenuation

## ◆ setPitch()

void sf::SoundSource::setPitch | ( | float | pitch | ) |
| inherited

Set the pitch of the sound.

The pitch represents the perceived fundamental frequency of a sound; thus you can make a sound more acute or grave by changing its pitch. A side effect of changing the pitch is to modify the playing speed of the sound as well. The default value for the pitch is 1.

Parameters

  pitch | New pitch to apply to the sound

See also
  getPitch

## ◆ setPlayingOffset()

void sf::SoundStream::setPlayingOffset | ( | Time | timeOffset | ) |
| inherited

Change the current playing position of the stream.

The playing position can be changed when the stream is either paused or playing. Changing the playing position when the stream is stopped has no effect, since playing the stream would reset its position.

Parameters

  timeOffset | New playing position, from the beginning of the stream

See also
  getPlayingOffset

## ◆ setPosition() [1/2]

void sf::SoundSource::setPosition | ( | const Vector3f & | position | ) |
| inherited

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  position | Position of the sound in the scene

See also
  getPosition

## ◆ setPosition() [2/2]

void sf::SoundSource::setPosition | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |
| inherited

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  x | X coordinate of the position of the sound in the scene
  y | Y coordinate of the position of the sound in the scene
  z | Z coordinate of the position of the sound in the scene

See also
  getPosition

## ◆ setRelativeToListener()

void sf::SoundSource::setRelativeToListener | ( | bool | relative | ) |
| inherited

Make the sound's position relative to the listener or absolute.

Making a sound relative to the listener will ensure that it will always be played the same way regardless of the position of the listener. This can be useful for non-spatialized sounds, sounds that are produced by the listener, or sounds attached to it. The default value is false (position is absolute).

Parameters

  relative | True to set the position relative, false to set it absolute

See also
  isRelativeToListener

## ◆ setVolume()

void sf::SoundSource::setVolume | ( | float | volume | ) |
| inherited

Set the volume of the sound.

The volume is a value between 0 (mute) and 100 (full volume). The default value for the volume is 100.

Parameters

  volume | Volume of the sound

See also
  getVolume

## ◆ stop()

void sf::SoundStream::stop | ( |  | ) |
| virtualinherited

Stop playing the audio stream.

This function stops the stream if it was playing or paused, and does nothing if it was already stopped. It also resets the playing position (unlike pause()).

See also
  play, pause

Implements sf::SoundSource.

## Member Data Documentation

## ◆ m_source

unsigned int sf::SoundSource::m_source
| protectedinherited

OpenAL source identifier.

Definition at line 309 of file SoundSource.hpp.

The documentation for this class was generated from the following file:

- Music.hpp